Index: /trunk/LMDZ.MARS/libf/aeronomars/photolysis.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/photolysis.F90	(revision 2006)
+++ /trunk/LMDZ.MARS/libf/aeronomars/photolysis.F90	(revision 2007)
@@ -3,5 +3,5 @@
       subroutine photolysis(nlayer,                              &
                             lswitch, press, temp, sza, tauref,   &
-                            dist_sol, rmco2, rmo3, j)
+                            zmmean, dist_sol, rmco2, rmo3, v_phot)
 
 !==========================================================================
@@ -23,4 +23,5 @@
       real :: sza                   ! solar zenith angle (deg)
       real :: tauref                ! optical depth at 7 hpa
+      real :: zmmean(nlayer)        ! mean molecular mass (g)
       real :: dist_sol              ! sun distance (AU) 
       real :: rmco2(nlayer)         ! co2 mixing ratio
@@ -31,5 +32,5 @@
 !==========================================================================
 
-      real :: j(nlayer,nd)          ! interpolated photolysis rates (s-1) 
+      real (kind = 8), dimension(nlayer,nb_phot_max) :: v_phot
 
 !==========================================================================
@@ -39,4 +40,12 @@
       integer :: icol, ij, indsza, indtau, indcol, indozo, indtemp,     &
                  iozo, isza, itau, it, l
+
+      integer :: j_o2_o, j_o2_o1d, j_co2_o, j_co2_o1d, j_o3_o1d,        &
+                 j_o3_o, j_h2o, j_hdo, j_h2o2, j_ho2, j_no, j_no2,      &
+                 j_hno3, j_hno4,                                        &
+                 j_ch4_ch3_h, j_ch4_1ch2_h2, j_ch4_3ch2_h_h,            &
+                 j_ch4_ch_h2_h, j_ch3o2h, j_ch2o_hco, j_ch2o_co,        &
+                 j_ch3oh, j_c2h6, j_hcl, j_hocl, j_clo, j_so2, j_so,    &
+                 j_h2s, j_so3
 
       real :: col(nlayer)                 ! overhead air column   (molecule cm-2)
@@ -49,4 +58,5 @@
       real :: ratio_o3(nlayer)
       real :: tau
+      real :: j(nlayer,nd)
 
 !==========================================================================
@@ -105,5 +115,5 @@
 
       col(lswitch-1) = 6.022e22*rmco2(lswitch-1)*press(lswitch-1)*100.  &
-                       /(mugaz*g)
+                       /(zmmean(lswitch-1)*g)
 
 !     ozone column at model top
@@ -116,8 +126,8 @@
          dp = (press(l) - press(l+1))*100.
          col(l) = col(l+1) + (rmco2(l+1) + rmco2(l))*0.5   &
-                             *6.022e22*dp/(mugaz*g)
+                             *6.022e22*dp/(zmmean(l)*g)
          col(l) = min(col(l), colairtab(1))
          colo3(l) = colo3(l+1) + (rmo3(l+1) + rmo3(l))*0.5 &
-                                 *6.022e22*dp/(mugaz*g)
+                                 *6.022e22*dp/(zmmean(l)*g)
       end do
 
@@ -295,4 +305,74 @@
       end if
 
+! photodissociation rates numbering in the lookup table
+
+! jmars.20140930
+
+      j_o2_o         =  1      ! o2 + hv     -> o + o
+      j_o2_o1d       =  2      ! o2 + hv     -> o + o(1d)
+      j_co2_o        =  3      ! co2 + hv    -> co + o
+      j_co2_o1d      =  4      ! co2 + hv    -> co + o(1d)
+      j_o3_o1d       =  5      ! o3 + hv     -> o2 + o(1d)
+      j_o3_o         =  6      ! o3 + hv     -> o2 + o
+      j_h2o          =  7      ! h2o + hv    -> h + oh
+      j_h2o2         =  8      ! h2o2 + hv   -> oh + oh
+      j_ho2          =  9      ! ho2 + hv    -> oh + o
+      j_no           =  10     ! no + hv     -> n + o
+      j_no2          =  11     ! no2 + hv    -> no + o
+      j_hno3         =  12     ! hno3 + hv   -> no2 + oh
+      j_hno4         =  13     ! hno4 + hv   -> no2 + ho2
+
+! jmars.20111014
+
+!     j_o2_o         =  1      ! o2 + hv     -> o + o
+!     j_o2_o1d       =  2      ! o2 + hv     -> o + o(1d)
+!     j_co2_o        =  3      ! co2 + hv    -> co + o
+!     j_co2_o1d      =  4      ! co2 + hv    -> co + o(1d)
+!     j_o3_o1d       =  5      ! o3 + hv     -> o2 + o(1d)
+!     j_o3_o         =  6      ! o3 + hv     -> o2 + o
+!     j_h2o          =  7      ! h2o + hv    -> h + oh
+!     j_hdo          =  8      ! hdo + hv    -> d + oh
+!     j_h2o2         =  9      ! h2o2 + hv   -> oh + oh
+!     j_ho2          =  10     ! ho2 + hv    -> oh + o
+!     j_no2          =  11     ! no2 + hv    -> no + o
+!     j_ch4_ch3_h    =  12     ! ch4 + hv    -> ch3 + h
+!     j_ch4_1ch2_h2  =  13     ! ch4 + hv    -> 1ch2 + h2
+!     j_ch4_3ch2_h_h =  14     ! ch4 + hv    -> 3ch2 + h + h
+!     j_ch4_ch_h2_h  =  15     ! ch4 + hv    -> ch + h2 + h
+!     j_ch3o2h       =  16     ! ch3o2h + hv -> ch3o + oh
+!     j_ch2o_hco     =  17     ! ch2o + hv   -> h + hco
+!     j_ch2o_co      =  18     ! ch2o + hv   -> h2 + co
+!     j_ch3oh        =  19     ! ch3oh + hv  -> ch3o + h
+!     j_c2h6         =  20     ! c2h6 + hv   -> products
+!     j_hcl          =  21     ! hcl + hv    -> h + cl
+!     j_hocl         =  22     ! hocl + hv   -> oh + cl
+!     j_clo          =  23     ! clo + hv    -> o + cl
+!     j_so2          =  24     ! so2 + hv    -> so + o
+!     j_so           =  25     ! so + hv     -> s + o
+!     j_h2s          =  26     ! h2s + hv    -> hs + s
+!     j_so3          =  27     ! so2 + hv    -> so2 + o
+!     j_hno3         =  28     ! hno3 + hv   -> oh + no2
+!     j_hno4         =  29     ! hno4 + hv   -> ho2 + no2
+
+! fill v_phot array
+
+      v_phot(:,:) = 0.
+
+      do l = 1,lswitch-1
+         v_phot(l, 1) = j(l,j_o2_o)
+         v_phot(l, 2) = j(l,j_o2_o1d)
+         v_phot(l, 3) = j(l,j_co2_o)
+         v_phot(l, 4) = j(l,j_co2_o1d)
+         v_phot(l, 5) = j(l,j_o3_o1d)
+         v_phot(l, 6) = j(l,j_o3_o)
+         v_phot(l, 7) = j(l,j_h2o)
+         v_phot(l, 8) = j(l,j_h2o2)
+         v_phot(l, 9) = j(l,j_ho2)
+         v_phot(l,10) = j(l,j_no)
+         v_phot(l,11) = j(l,j_no2)
+      end do
+
       return
       end
+
+!*****************************************************************
Index: /trunk/LMDZ.MARS/libf/phymars/physiq_mod.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/physiq_mod.F	(revision 2006)
+++ /trunk/LMDZ.MARS/libf/phymars/physiq_mod.F	(revision 2007)
@@ -241,6 +241,4 @@
       real zcondicea_co2microp(ngrid,nlayer)
 c     Variables used by the photochemistry
-      logical :: asis             ! true  : adaptative semi-implicit symmetric (asis) chemical solver
-                                  ! false : euler backward chemical solver
       REAL surfdust(ngrid,nlayer) ! dust surface area (m2/m3, if photochemistry)
       REAL surfice(ngrid,nlayer)  !  ice surface area (m2/m3, if photochemistry)
@@ -1588,16 +1586,4 @@
      $                       surfdust, surfice)
 !           call photochemistry
-!           asis = .false.  euler-backward scheme 
-!           asis = .true.   asis scheme 
-
-            asis = .true.
-
-            if (asis) then
-            call calchim_asis(ngrid,nlayer,nq,
-     &                   ptimestep,zplay,zplev,pt,pdt,dist_sol,mu0,
-     $                   zzlev,zzlay,zday,pq,pdq,zdqchim,zdqschim,
-     $                   zdqcloud,zdqscloud,tauref,co2ice,
-     $                   pu,pdu,pv,pdv,surfdust,surfice)
-            else
             call calchim(ngrid,nlayer,nq,
      &                   ptimestep,zplay,zplev,pt,pdt,dist_sol,mu0,
